"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Date(ProtocolElement):
    """
    This defines a date record
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "year",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_7 import participant as participant_1_3_0

        return {
            "org.gel.models.participant.avro.Date": participant_1_3_0.Date,
        }

    __slots__ = [
        "year",
        "day",
        "month",
    ]

    def __init__(
        self,
        year,
        day=None,
        month=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_3_0.Date model.

        :param year:
            Format YYYY
        :type year: int
        :param day:
            Format DD e.g. 12th of October is 12
        :type day: None | int
        :param month:
            Format MM. e.g June is 06
        :type month: None | int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
